#import "drawundo.h"

@interface LineColorGraphicsChange(PrivateMethods)

- (BOOL)subsumeIdenticalChange:change;

@end

@implementation LineColorGraphicsChange

- initGraphicView:aGraphicView color:(const NXColor *)aColor
{
    [super initGraphicView:aGraphicView];
    color = *aColor;
    return self;
}

- (const char *)changeName
{
    return NXLocalStringFromTable("Operations", "Line Color", NULL, "The operation of changing the color of a line segment.");
}

- changeDetailClass
{
    return [LineColorChangeDetail class];
}

- (NXColor)lineColor
{
    return color;
}

- (BOOL)subsumeIdenticalChange:change
{
    color = [(LineColorGraphicsChange *)change line(r];
    return YES;
}

@end
