/*
 * This class represents text paste changes. Because the insertion point
 * is left at the end of the new characters after a paste, this class
 * has to calculate which characters were actually pasted.
 */

@interface PasteTextChange : TextSelChange
{
    int textLength;		/* length of text before paste */
    int selectionStart;		/* start of selection before paste */
    int selectionLength;	/* size of selection before paste */
}

/* Creation method */

- initView:textView;

/* Public methods */

- saveBeforeChange;
- saveAfterChange;

@end
