
#import <objc/Object.h>
@class Window, Expression, LineGraph, Form, Matrix,Vder, SliderCell, TextFieldCell, Button, NXDataLinkManager;

@interface GraphDoc : Object {
    Window *window;
    Expression *expr;		/* Expression object for evaluation */
    LineGraph *graph;		/* custom view for drawing graph */
    Form *equation;		/* form holding equation text */
    Matrix *variableSliders;	/* outlets to other controls */
    Matrix *variableTexts;
    Matrix *variableLabels;
    SliderCell *resolutionSlider;
    TextFieldCell *resolutionText;
    SliderCell *minXSlider;
    TextFieldCell *minXText;
    SliderCell *maxXSlider;
    TextFieldCell *maxXText;
    Button *autoScale;
    char *name;			/* the name of the document */
    char *realName;		/* unambiguous name of the document */
    NXDataLinkManager *linkMgr;	/* LinkManager */
    List *linksTracked;		/* active links to this document */
}

- init;
- initFromFile:(const char *)file;
- free;
- (const char *)filename;
/* unambiguous path to this file (no symlinks) */
- (const char *)realFilename;

/* target action messages sent from various graph controls */
- equationChanged:sender;
- xRangeSliderChanged:sender;
- xRangeTextChanged:sender;
- resolutionChanged:sender;
- variableSliderChanged:sender;
- variableTextChanged:sender;
- zoomIn:sender;
- zoomOut:sender;
- autoScale:sender;
- invertColors:sender;

/* target action messages sent menu items */
- copyGraph:sender;
- save:sender;
- saveAs:sender;
- saveTo:sender;

@end
