/* Controller.h:
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or  implied, as to its
 * fitness for any particular use.
 *
 * Written by Mai Nguyen, NeXT Developer Support
 *
 */

#import <objc/Object.h>


@interface Controller:Object
{
	id	theWindow;			/* The main application window */
    id	dbModule;			/* DBModule instance representing the Authors
			          	   	   table */
   	id  dbDatabase;			/* the pubs database */	
	id	dbRecordList;
	id	dbTableView;
	id	dbQualifier;
	id	dbFetchGroup;
	id	sortProp;			/* Property used for sorting	*/
  	id 	aValue;				/* a DBValue instance to look at record contents */	
	int recordOrder;		/* Record retrieval order */
	id 	formMatrix;			/* Author data form matrix */
	id	qualifierField;		/* Text field to build the query before a SELECT */
	id	textView;			/* ScrollView inside the SQL panel */
	id	queryField;			/* Text field to contain an SQL query */		
}

- select:sender;
- insert:sender;
- checkInputRecord:sender;
- display;
- clearData;
- fillNewRecordAt:(int)index;
- changeRetrieveOrder:sender;
- buildSelectQualifier:sender; 
- appendToView:(id)scrollView text:(const char *)newText;
- evaluateSQL:sender;

/* Controller Object Delegate methods */
- fetchGroup:fetchGroup didInsertRecordAt:(int)index;
- fetchGroupDidSave:fetchGroup;
- fetchGroupWillFetch:fetchGroup;


@end

