
/* Thinker.h */

#import "Spot.h"
#import <appkit/appkit.h>
#import <remote/NXProxy.h>

@protocol spotClientMethods
- spotList;
- (oneway void) useSpotList: (bycopy in id) newSpotList;
- (oneway void) serverTerminated;
@end

@protocol spotServerMethods
- (void) addClient:(id <spotClientMethods>)remoteClient
	r:(out float *)r
	g:(out float *)g
	b:(out float *)b;
- nukeClient: theClientRecord;
- (void) clientTerminated:(in id)sender;
- (oneway void) sendSpotListToClients;
- getSpotForPoint:(NXPoint) pnt spotLocation:(out NXPoint *)loc;
- (oneway void) spotDidChange;
@end

@interface Thinker:Object <spotServerMethods, spotClientMethods, NXSenderIsInvalid>
{
    id	win;
    id	mySpotView;
    id	spotList;
	id server;
	BOOL isServer;
	NXConnection *myConnection;

	id	clientList;
}

- appDidInit:sender;
- appWillTerminate:sender;
- server;
- (BOOL)isServer;

@end

